/**
* user:  B1001
* fname: Georgi
* lname: Petkov
* task:  bridges
* score: 30.0
* date:  2017-11-25 11:53:04.922196
*/
#include <bits/stdc++.h>
#define MAXN 1024
using namespace std;
int n, m;
vector <int> v[MAXN];
int cnt[MAXN][MAXN];
int pos;
bool used[MAXN];
void dfs(int ver)
{
    pos = ver;
    used[ver] = 1;
    for (int i = 0; i < v[ver].size(); i++)
    {
        if (cnt[ver][v[ver][i]] % 2 == 0 & cnt[ver][v[ver][i]] >= 2)
            used[v[ver][i]] = 1;
        cnt[ver][v[ver][i]] %= 2;
        cnt[v[ver][i]][ver] %= 2;
    }
    for (int i = 0; i < v[ver].size(); i++)
        if (cnt[ver][v[ver][i]])
    {
        cnt[ver][v[ver][i]]--;
        cnt[v[ver][i]][ver]--;
        dfs(v[ver][i]);
        break;
    }
}
int main()
{
    cin >> n >> m;
    for (int i = 1; i <= m; i++)
    {
        int a, b;
        cin >> a >> b;
        v[a].push_back(b);
        v[b].push_back(a);
        cnt[a][b]++;
        cnt[b][a]++;
    }
    dfs(1);
    vector <pair <int, int> > unused;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= n; j++)
        if (cnt[i][j] && i < j) unused.push_back(make_pair(i, j));
    vector <pair <int, int> > edge;
    for (int i = 1; i <= n; i++)
        if (!used[i])
    {
        edge.push_back(make_pair(pos, i));
        pos = i;
    }
    for (int i = 0; i < unused.size(); i++)
    {
        edge.push_back(make_pair(pos, unused[i].first));
        pos = unused[i].second;
    }
    if (pos != 1) edge.push_back(make_pair(pos, 1));
    cout << edge.size() << endl;
    for (int i = 0; i < edge.size(); i++)
        cout << edge[i].first << " " << edge[i].second << endl;
}
/*
4 7
1 2
2 3
3 2
2 1
1 4
2 4
3 4
*/
