/**
* user:  B1002
* fname: Konstantin
* lname: Kamenov
* task:  bridges
* score: 100.0
* date:  2017-11-25 09:02:39.984859
*/
#include<iostream>
#include<vector>
struct edge
{
    int beg,end;
};
int degrees[1000];

int nodeComp[1000];
int compNode[1000];
int compCnt=0;
bool visited[1000];
std::vector<int>susedi[1000];
std::vector<int>component[1000];
std::vector<int>rest;
std::vector<edge>answers;
void dfs(int node)
{
    if(visited[node])
    {
        return;
    }
    nodeComp[node]=compCnt;
    visited[node]=1;
    if(degrees[node]%2==1)
    {
        component[compCnt].push_back(node);
    }
    for(int i=0; i<susedi[node].size(); i++)
    {
        dfs(susedi[node][i]);
    }
}
int main()
{
    int m,n;
    std::cin>>n>>m;
    int a,b;
    for(int i=0; i<m; i++)
    {
        std::cin>>a>>b;
        a--;
        b--;
        degrees[a]++;
        degrees[b]++;
        susedi[a].push_back(b);
        susedi[b].push_back(a);
    }
    for(int i=0; i<n; i++)
    {
        if(!visited[i])
        {
            compNode[compCnt]=i;
            dfs(i);
            if(component[compCnt].size()==0)
            {
                component[compCnt].push_back(i);
                component[compCnt].push_back(i);
            }
            compCnt++;
        }
    }
    bool needed=1;
    if(compCnt==1 && component[0][0]==component[0][1])
    {
        needed=0;
    }
    for(int i=0; i<compCnt-1; i++)
    {
        answers.push_back({component[i][0],component[i+1][1]});
        for(int j=2; j<component[i].size(); j++)
        {
            rest.push_back(component[i][j]);
        }
    }
    answers.push_back({component[compCnt-1][0],component[0][1]});
    for(int j=2; j<component[compCnt-1].size(); j++)
    {
        rest.push_back(component[compCnt-1][j]);
    }
    for(int i=0; i<rest.size(); i+=2)
    {
        answers.push_back({rest[i],rest[i+1]});
    }
    if(needed)
    {
        std::cout<<answers.size()<<std::endl;
        for(int i=0; i<answers.size(); i++)
        {
            std::cout<<answers[i].beg+1<<" "<<answers[i].end+1<<std::endl;
        }
    }
    else
    {
        std::cout<<0<<std::endl;
    }
    return 0;
}
