/**
* user:  B1003
* fname: Martin
* lname: Kopchev
* task:  bridges
* score: 100.0
* date:  2017-11-25 11:05:12.300812
*/
#include<bits/stdc++.h>
using namespace std;
const int nmax=1e3+42;
int n,m;
int SZ[nmax];
vector<int> adj[nmax];
vector< pair<int,int> >outp;
void solve()
{
for(int i=1;i<=n;i++)
    for(int j=i+1;j<=n;j++)
    if(SZ[i]%2==1&&SZ[j]%2==1)
    {
    outp.push_back({i,j});
    SZ[i]++;
    SZ[j]++;
    }
}
int parent[nmax];
int root(int node)
{
if(parent[node]==node)return node;
parent[node]=root(parent[node]);
return parent[node];
}
void print()
{
int sz=outp.size();
cout<<sz<<endl;
for(auto k:outp)
    cout<<k.first<<" "<<k.second<<endl;
//for(int i=1;i<=n;i++)cout<<parent[i]<<" ";cout<<endl;
}
vector<int> alone;
int comp;
void odd(int i)
{
for(int j=i+1;j<=n;j++)
if(root(i)!=root(j)&&SZ[i]%2==1&&SZ[j]%2==1)
{
outp.push_back({i,j});
SZ[i]++;
SZ[j]++;
parent[root(i)]=root(j);
comp--;
}

}
int main()
{
cin>>n>>m;
for(int i=1;i<=n;i++)parent[i]=i;
int a,b;
comp=n;
for(int i=1;i<=m;i++)
{
cin>>a>>b;
SZ[a]++;
SZ[b]++;
adj[a].push_back(b);
adj[b].push_back(a);
if(root(b)!=root(a)){parent[root(b)]=root(a);comp--;}
}
for(int i=1;i<=n;i++)
    if(adj[i].size()==0)
    {
    alone.push_back(i);
    }
int S=alone.size();
for(int i=1;i<S;i++)
{
SZ[alone[i-1]]++;
SZ[alone[i]]++;
outp.push_back({alone[i-1],alone[i]});
if(root(alone[i-1])!=root(alone[i])){parent[root(alone[i-1])]=root(alone[i]);comp--;}
}
//print();
while(comp>=2)
{
//two odd
for(int i=1;i<=n;i++)
    odd(i);
//print();
//odd and even
for(int i=1;i<=n;i++)
    for(int j=i+1;j<=n;j++)
        if(root(i)!=root(j)&&SZ[i]%2+SZ[j]%2==1)
        {
        outp.push_back({i,j});
        SZ[i]++;
        SZ[j]++;
        parent[root(i)]=root(j);
        comp--;
        odd(i);
        odd(j);
        }
//print();
//two even
for(int i=1;i<=n;i++)
    for(int j=i+1;j<=n;j++)
        if(root(i)!=root(j)&&SZ[i]%2==0&&SZ[j]%2==0)
        {
        outp.push_back({i,j});
        SZ[i]++;
        SZ[j]++;
        parent[root(i)]=root(j);
        comp--;
        odd(i);
        odd(j);
        }
//print();
}
//Must be connected
solve();
print();
return 0;
}
/*
4 7
1 2
2 3
3 2
2 1
1 4
2 4
3 4


4 5
1 2
2 3
3 1
3 4
3 4

4 3
1 2
2 3
3 1

4 2
1 2
3 4

6 2
3 4
5 6

6 4
1 2
3 4
4 5
5 6

12 12
1 2
1 3
2 3
3 4
4 5
4 6
5 6
7 8
8 9
9 10
10 11
9 12

4 3
1 2
1 2
3 4

6 5
1 2
2 1
3 4
4 3
5 6

7 3
7 4
4 6
6 7

8 7
3 4
4 2
2 3
1 8
8 5
5 6
6 1


6 4
3 2
1 2
5 6
3 1
*/
