/**
* user:  B1006
* fname: Dobrin
* lname: Bashev
* task:  chain
* score: 35.294117652
* date:  2017-11-25 07:54:31.349054
*/
#include <iostream>
#include <set>
#include <utility>
#define fi first
#define se second
#define endl '\n'
using namespace std;

const int MAXN = 500005;
const int MAXR = 1000;

int n;
int a[MAXN], b[MAXN];
int s[MAXN];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    for (int i = n; i >= 1; -- i)
    {
        cin >> a[i];
    }

    int block = 1;
    for (int i = 1; i <= n; ++ i)
    {
        int idx = -1;
        for (int j = block; j >= 0; -- j)
        {
            if (s[j] > a[i])
            {
                idx = j;
                break;
            }
        }

        if (idx == -1)
        {
            b[i] = 0;

        }
        else
        {
            int pos;
            for (int j = min(idx * MAXR - 1, i - 1); j >= 1; -- j)
            {
                if (a[j] > a[i])
                {
                    pos = j;
                    break;
                }
            }
            b[i] = b[pos] + 1;
        }
        s[block] = max(s[block], a[i]);
        if (i % MAXR == 0) block++;
    }

    for (int i = n; i >= 1; -- i)
    {
        cout << b[i] << ' ';
    }

    cout << endl;
    return 0;
}

/*
11
3 2 4 2 11 2 7 5 8 10 6
*/
