/**
* user:  B1006
* fname: Dobrin
* lname: Bashev
* task:  shopping
* score: 20.0
* date:  2017-11-25 10:37:10.081141
*/
#include <iostream>
#define fi first
#define se second
#define endl '\n'
using namespace std;

const int MAXK = 100005;

int t, k, n;
int a[MAXK];

int gcd(int a, int b)
{
    if (a < b) swap(a, b);
    while (b != 0)
    {
        int tmp = a % b;
        a = b;
        b = tmp;
    }
    return a;
}

pair<int, int> Solve(int a, int b)
{
    int x0 = 1, x1 = 0;
    int y0 = 0, y1 = 1;

    bool fl = false;
    if (a < b)
    {
        swap(a, b);
        fl = true;
    }

    int nod = gcd(a, b);
    a /= nod;
    b /= nod;

    while (b != 0)
    {
        int tmp = a % b;
        int div = a / b;

        int x = x0 - x1 * div;
        int y = y0 - y1 * div;

        x0 = x1; y0 = y1;
        x1 = x; y1 = y;
        a = b;
        b = tmp;
    }

    swap(x0, y0);
    return make_pair(x0, y0);
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> t;
    while (t--)
    {
        cin >> k;
        for (int i = 1; i <= k; ++ i)
        {
            cin >> a[i];
        }
        cin >> n;

        bool fl = false;
        for (int i = 1; i <= k; ++ i)
        {
            if (fl) break;
            for (int j = i + 1; j <= k; ++ j)
            {
                int nod = gcd(a[i], a[j]);
                if (n % nod == 0)
                {
                    auto e = Solve(a[i], a[j]);
                    for (int l = 1; l <= k; ++ l)
                    {
                        if (l == i)
                        {
                            cout << e.fi << '*' << n / nod << ' ';
                            continue;
                        }
                        if (l == j)
                        {
                            cout << e.se << '*' << n / nod << ' ';
                            continue;
                        }
                        cout << 0 << ' ';
                    }
                    cout << endl;
                    fl = true;
                    break;
                }
            }
        }
        if (!fl) cout << "No solutions" << endl;
    }
    return 0;
}

/*
1
2
3 5
11
*/
