/**
* user:  B1007
* fname: Marin
* lname: Jordanov
* task:  shopping
* score: 100.0
* date:  2017-11-25 10:51:31.646204
*/
#include<bits/stdc++.h>
using namespace std;
long long t;
long long n;
long long a[131072];
bool sign[131072];
vector<long long>answer[131072];
void extended_euclid2(long long a,long long b,long long &x1,long long &y1,long long &d)
{
    x1=1,y1=0;
    long long x2=0,y2=1;
    while (b)
    {
        long long r=a%b;
        long long q=a/b;
        long long t;
        a=b;b=r;

        t=x2;
        x2=x1-q*x2;
        x1=t;

        t=y2;
        y2=y1-q*y2;
        y1=t;
    }
    d=a;
}
void print_answer(void)
{
    int i;
    for (i=0;i<n;i++)
    {
        int sz=answer[i].size(),j;
        if (!sz)
        {
            printf("0");
            //cout<<0;
            if (i+1==n)
                printf("\n");
            else
                printf(" ");
        }
        else
        {
            if (sign[i])
                printf("-");
            printf("%d",answer[i][0]);
            //cout<<answer[i][0];
            for (j=1;j<sz;j++)
            {
                printf("*%d",answer[i][j]);
                //cout<<"*"<<answer[i][j];
            }
            if (i+1==n)
                printf("\n");
            else
                printf(" ");
        }
    }
}
long long nod(long long a,long long b)
{
    while (a&&b)
    {
        if (a>b)a%=b;
        else b%=a;
    }
    return a+b;
}
int main()
{
    scanf("%lld",&t);
    while (t--)
    {
        int i,j;
        scanf("%lld",&n);
        for (i=0;i<n;i++)
            scanf("%lld",&a[i]);
        long long x1,y1,d;
        extended_euclid2(a[0],a[1],x1,y1,d);
        if (x1>=0)
        answer[0].push_back(x1);
        else
        {
            answer[0].push_back(0-x1);
            sign[0]=true;
        }
        if (y1>=0)
        answer[1].push_back(y1);
        else
        {
            answer[1].push_back(0-y1);
            sign[1]=true;
        }
        vector<int>written;
        written.push_back(0);
        written.push_back(1);
        int WrittenCnt=2;
        long long nd=nod(a[0],a[1]);
        long long NeedNum;
        scanf("%lld",&NeedNum);
        for (i=2;i<n;i++)
        {
            if (nod(nd,a[i])!=nd)
            {
                extended_euclid2(nd,a[i],x1,y1,d);
                bool NowSign=false;
                if (x1<0)
                {
                    x1=0-x1;
                    NowSign=true;
                }
                if (NowSign)
                for (j=0;j<WrittenCnt;j++)
                {
                    sign[written[j]]^=true;
                }
                for (j=0;j<WrittenCnt;j++)
                {
                    answer[written[j]].push_back(x1);
                }
                if (y1<0)
                {
                    sign[i]=true;
                    y1=0-y1;
                }
                answer[i].push_back(y1);
                nd=nod(nd,a[i]);
                written.push_back(i);
                WrittenCnt++;
            }
        }
        if (NeedNum%nd)
        {
            printf("No solutions\n");
            //cout<<"No solutions"<<endl;
            for (i=0;i<n;i++)
                while (answer[i].size()>0)
                    answer[i].pop_back();
            memset(sign,0,sizeof(sign));
            continue;
        }
        long long mul=NeedNum/nd;
        for (i=0;i<n;i++)
        {
            if (answer[i].size())
            {
                answer[i].push_back(mul);
            }
        }
        print_answer();
        for (i=0;i<n;i++)
        while (answer[i].size()>0)
            answer[i].pop_back();
        memset(sign,0,sizeof(sign));
    }
    return 0;
}
