/**
* user:  B1008
* fname: Viktor
* lname: Kojuharov
* task:  shopping
* score: 20.0
* date:  2017-11-25 09:09:30.363094
*/
#include<iostream>
#include<vector>
#include<cstdlib>

using namespace std;

long long extended_euclid(long long a,long long b,long long &x,long long &y)
{
    if(b==0)
    {
        x=1;
        y=0;
        return a;
    }

    long long x2,y2;
    long long d=extended_euclid(b,a%b,x2,y2);

    x=y2;
    y=x2-(a/b)*y2;

    return d;
}

long long a[100001];
long long b[100001];
vector<long long> c[100001];

int main ()
{
    long long t;
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>t;
    for(t;t>0;t--)
    {
        long long k,i,n,x,y,st=1,j,p;

        cin>>k;
        //k=100000;

        for(i=0;i<k;i++)
            cin>>a[i];

        cin>>n;
        //n=rand()%100000+1;

        p=k;

        for(i=0;i<k;i++)b[i]=a[i];

        while(p>1)
        {
            //cout<<p<<" "<<st<<endl;
            for(i=0;i<=(p-2);i+=2)
            {
                b[i]=extended_euclid(b[i],b[i+1],x,y);
                //cout<<i<<endl;
                for(j=i*st;j<(i+1)*st;j++)c[j].push_back(x);
                for(j=(i+1)*st;j<(i+2)*st && j<k;j++)c[j].push_back(y);
            }

            for(i=0;i<=(p-2)/2;i++)
            {
                b[i]=b[2*i];
            }
            st*=2;
            p=p/2+p%2;
        }

        if(n%b[0]!=0)
        {
            cout<<"No solutions"<<endl;
            for(i=0;i<k;i++)while(!c[i].empty())c[i].pop_back();
            continue;
        }
        n=n/b[0];

        for(i=0;i<k;i++)c[i].push_back(n);

        for(i=0;i<k;i++)
        {
            for(j=0;j<c[i].size()-1;j++)
            {
                cout<<c[i][j]<<"*";
            }
            cout<<c[i][j]<<" ";
            while(!c[i].empty())c[i].pop_back();
        }
        cout<<endl;

    }

    return 0;
}
