/**
* user:  B1010
* fname: Veselin
* lname: Dimov
* task:  bridges
* score: 20.0
* date:  2017-11-25 09:45:20.634769
*/
#include <iostream>
#include <vector>
using namespace std;

int n, m;
vector <int> a[10002];
vector <int> newc;
int p=0;

bool visited[1024];

void DFS (int u)
{
    visited[u]=true;
    for (int i=0; i<a[u].size (); i++)
    {
        int v=a[u][i];
        if (visited[v]) continue;
        DFS (v);
    }
}

void Build_Bridges ()
{
    int index=-1;
    for (int i=1; i<=n; i++)
    {
        if (a[i].size ()%2==0) continue;
        if (index==-1)
        {
            index=i;
            continue;
        }
        cout<<index<<' '<<i<<endl;
        index=-1;
    }
    for (int i=0; i<p; i++)
        cout<<"1 "<<newc[i]<<"\n1 "<<newc[i]<<'\n';
}

int main ()
{
    cin>>n>>m;
    for (int i=0; i<m; i++)
    {
        int u, v;
        cin>>u>>v;
        a[u].push_back (v);
        a[v].push_back (u);
    }
    for (int i=0; i<=n; i++)
        visited[i]=false;
    int cnt=0;
    for (int i=1; i<=n; i++)
        if (a[i].size ()%2==1) cnt++;
    cnt/=2;
    for (int i=1; i<=n; i++)
    {
        if (visited[i])
            continue;
        if (i!=1)
        {
            p++;
            newc.push_back (i);
        }
        DFS (i);
    }
    cout<<(cnt+(p*2))<<endl;
    Build_Bridges ();
    return 0;
}
