/**
* user:  B1011
* fname: Stoyan
* lname: Malinin
* task:  shopping
* score: 10.0
* date:  2017-11-25 08:39:48.768012
*/
#include<iostream>

using namespace std;

const int MAXN = 1005;

int T;

int k;
long long s[MAXN], n;

long long x1, x2, y1, y2, r, q;
long long a, b, c;

int extEuclid()
{
    x1 = 1;y1 = 0;
    x2 = 0;y2 = 1;
    while(b!=0)
    {
        r = a%b;
        q = a/b;

        a = b;
        b = r;

        r = x1 - x2*q;
        x1 = x2;x2 = r;

        r = y1 - y2*q;
        y1 = y2;y2 = r;

        //cout << y2 << " " << b << '\n';
    }

    return a;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int operations;
    long long x, y, n1;

    cin >> T;
    for(int t = 0;t<T;t++)
    {
        cin >> k;
        for(int i = 0;i<k;i++)
            cin >> s[i];
        cin >> n;
        n1 = n;

        if(k==2)
        {
            a = s[0];
            b = s[1];
            long long d = extEuclid();


            //cout << x1 << " " << y1 << " || " << x2 << " " << y2 << '\n';

            x = x1;
            y = y1;

            //cout << y << '\n';
            //cout << s[0] << "*" << x*(n/d) << " + " << s[1] << "*" << y*(n/d) << '\n';

            if( s[0] * x*(n/d) + s[1] * y*(n/d) != n )cout << "No solutions" << '\n';
            else cout << x*(n/d) << " " << y*(n/d) << '\n';
        }
        else if(k==3)
        {
            cout << 1/0 << '\n';

            operations = 0;

            for(int i = 0;;i++)
            {
                operations++;

                a = s[0];
                b = s[1];
                n = n1 + s[2]*i;

                long long d = extEuclid();


                //cout << x1 << " " << y1 << " || " << x2 << " " << y2 << '\n';

                x = x1;
                y = y1;

                //cout << y << '\n';
                //cout << s[0] << "*" << x*(n/d) << " + " << s[1] << "*" << y*(n/d) << '\n';

                if( s[0] * x*(n/d) + s[1] * y*(n/d) == n)
                {
                    cout << x*(n/d) << " " << y*(n/d) << " " << i << '\n';
                    break;
                }
                if(operations>=5*1e5)
                {
                    cout << "No solution" << '\n';
                    break;
                }
            }
        }
    }
}
