/**
* user:  B1011
* fname: Stoyan
* lname: Malinin
* task:  chain
* score: 100.000000014
* date:  2017-11-25 12:11:30.889622
*/
#include<iostream>
#include<stack>

using namespace std;

const int MAXN = 5*1e5 + 5;

int n;
int a[MAXN];

int dp[MAXN];
stack < pair <int, int> > s;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int nextIndex;

    cin >> n;
    for(int i = 0;i<n;i++)
        cin >> a[i];

    s.push(make_pair(a[n-1], n-1));
    for(int i = n-2;i>=0;i--)
    {
        nextIndex = -1;
        while(s.empty()==false)
        {
            if(s.top().first>a[i])
            {
                nextIndex = s.top().second;
                break;
            }
            s.pop();
        }

        if(nextIndex!=-1) dp[i] = dp[nextIndex] + 1;
        s.push(make_pair(a[i], i));
    }

    cout << dp[0];
    for(int i = 1;i<n;i++)
        cout << " " << dp[i];
    cout << '\n';
}
/*
11
3 2 4 2 11 2 7 5 8 10 6
*/
