/**
* user:  B1016
* fname: Alex
* lname: Tsvetanov
* task:  bridges
* score: 20.0
* date:  2017-11-25 08:02:56.881631
*/
#include <iostream>
#include <vector>

using namespace std;

bool power [1000];

int main ()
{
    cin.tie (nullptr);
    ios::sync_with_stdio (false);
    int n, m;
    cin >> n >> m;
    
    for (int i = 0 ; i < m ; i ++)
    {
	int a, b;
	cin >> a >> b;
	a --; b --;
	power [a] = not power [a];
	power [b] = not power [b];
    }
    
    bool zero = true;

    for (int i = 0 ; i < n ; i ++)
    {
	//cout << power [i] << " ";
	if (power [i])
	{
	    zero = false;
	    break;
	}
    }
    //cout << endl;
    
    if (zero)
    {
	cout << 0 << endl;
	return 0;
    }
    
    vector < int > odds;

    for (int i = 0 ; i < n ; i ++)
	if (power [i])
	    odds.push_back (i);
    cout << odds.size () / 2 << endl;
    for (int i = 0 ; i < odds.size () ; i += 2)
	cout << odds [i] + 1 << " " << odds [i + 1] + 1 << endl;
}

