/**
* user:  B1064
* fname: Лъчезар Лъчезаров Кеманов
* lname: Варна
* task:  bridges
* score: 20.0
* date:  2017-11-25 11:46:49.731116
*/
#include  <iostream>
#include  <algorithm>
#include  <vector>
#define MAXN 1000
#define MAXM 10000
using  namespace  std;
vector <int> v[MAXN];
int used[MAXN][MAXN];
bool f=false;
int n,m,t,br=0;


struct bridge
{
    int x;
    int y;

};


bridge b[MAXM];
vector <bridge> ans[MAXN];


bool cmp(bridge a, bridge c)
{
    if(a.x==c.x)
        return a.y<c.y;
    return a.x<c.x;
}

void visit(void)
{
    for(int a=0; a<m; a++)
    {
        int h,g;
        h=b[a].x;
        g=b[a].y;
        used[h][g]++;
        used[g][h]++;
    }
}
int unvisited(void)
{
    for(int a=0; a<m; a++)
    {
        int h,g;
        h=b[a].x;
        g=b[a].y;
        if(used[h][g])return h;
    }
    return 0;
}


void dfs(int s)
{
    if(f==true)return ;
    for(int a=0; a<v[s].size(); a++)
    {
        int x;
        x=v[s][a];
        if(used[s][x])
        {
            used[s][x]--;
            used[x][s]--;
            dfs(x);
        }
    }
    int k=unvisited();
    if(k==0 && s==t && f==false)
    {
        f=true;
        return;
    }
    else if(k==0 && s!=t && f==false)
    {
        ///cout<<s<<" "<<t<<endl;
        bridge l;
        l.x=s;
        l.y=t;
        ans[t].push_back(l);
        f=true;
        return;
    }
    if(k!=0)
    {
        br++;
        bridge l;
        l.x=s;
        l.y=k;
        ans[t].push_back(l);
    }

    dfs(k);
}


int main()
{
    cin>>n>>m;
    for(int a=0; a<m; a++)
    {
        int c,d;
        cin>>c>>d;
        if(c>d)swap(c,d);
        used[c][d]++;
        used[d][c]++;
        b[a].x=c;
        b[a].y=d;
        v[c].push_back(d);
        v[d].push_back(c);
    }

    int g=0,z=MAXM;
    for(int a=1; a<=n; a++)
    {
        f=false;
        t=a;
        dfs(t);
        if(ans[a].size()<z)
        {
            z=ans[a].size();
            g=a;
        }
        if(z==0) break;
        visit();
    }

    if(z==0)cout<<0<<endl;
    else
    {
        cout<<z<<endl;
        for(int a=0; a<z; a++)
        cout<<ans[g][a].x<<" "<<ans[g][a].y<<endl;
    }
    return 0;
}
/**
4 7
1 2
2 3
3 2
2 1
1 4
2 4
3 4

*/
