/**
* user:  B1073
* fname: Биляна Емилова Инджева
* lname: Русе
* task:  bridges
* score: 0.0
* date:  2017-11-25 11:12:47.902886
*/
#include<iostream>
#include<vector>

using namespace std;

const int MAXV=1000;
int v, e;
vector<int> con[MAXV];
bool used[MAXV];
int path[MAXV], oldpath[MAXV];
int c;
vector<int> uv[MAXV];
int br;
int ans;
int res[MAXV][2];

void input()
{
    int a, b;
    cin>>v>>e;
    for (int i=0; i<e; i++)
    {
        cin>>a>>b;
        con[a-1].push_back(b-1);
        con[b-1].push_back(a-1);
    }
    c=e;
}

void output()
{
    cout<<ans<<endl;
    for (int i=0; i<ans; i++)
    {
        cout<<res[i][0]+1<<' '<<res[i][1]+1<<endl;
    }
}

void remove_edge(int curr)
{
    int p=curr;
    int temp=p;
    do
    {
        //cerr<<p+1<<' '<<path[p]+1<<endl;
        if (p<path[p])
        {
            for (int i=0; i<uv[p].size(); i++)
            {
                if (uv[p][i]==path[p])
                {
                    swap(uv[p][i], uv[p][uv[p].size()-1]);
                    uv[p].pop_back();
                    break;
                }
            }
        }
        else
        {
            for (int i=0; i<uv[path[p]].size(); i++)
            {
                if (uv[path[p]][i]==p)
                {
                    swap(uv[path[p]][i], uv[path[p]][uv[path[p]].size()-1]);
                    uv[path[p]].pop_back();
                    break;
                }
            }
        }
        used[p]=0;
        temp=path[p];
        path[p]=oldpath[p];
        oldpath[p]=-1;
        p=temp;
        c--;
        //cout<<path[p]<<' '<<oldpath[p]<<endl;
    }
    while (p!=curr);
}

void dfs(int curr)
{
    int temp;
    //cerr<<curr<<endl;
    if (used[curr]==1) remove_edge(curr);
    used[curr]=1;
    for (int i=0; i<con[curr].size(); i++)
    {
        used[curr]=1;
        if (con[curr][i]<curr)
        {
            uv[con[curr][i]].push_back(curr);
        }
        else
        {
            uv[curr].push_back(con[curr][i]);
        }
        for (int j=0; j<con[con[curr][i]].size(); j++)
        {
            if (con[con[curr][i]][j]==curr)
            {
                swap(con[con[curr][i]][j], con[con[curr][i]][con[con[curr][i]].size()-1]);
                con[con[curr][i]].pop_back();
                break;
            }
        }
        temp=con[curr][i];
        swap(con[curr][i], con[curr][con[curr].size()-1]);
        con[curr].pop_back();
        oldpath[temp]=path[temp];
        path[temp]=curr;
        dfs(temp);
    }
}

int dfs2(int curr, int b)
{
    bool ch=0;
    int temp;
    for (int i=0; i<uv[curr].size(); i++)
    {
        ch=1;
        for (int j=0; j<uv[uv[curr][i]].size(); j++)
        {
            if (uv[uv[curr][i]][j]==curr)
            {
                swap(uv[uv[curr][i]][j], uv[uv[curr][i]][uv[uv[curr][i]].size()-1]);
                uv[uv[curr][i]].pop_back();
                break;
            }
        }
        temp=uv[curr][i];
        swap(uv[curr][i], uv[curr][uv[curr].size()-1]);
        uv[curr].pop_back();
        dfs2(temp, b);
    }
    if (ch==0 && curr!=b)
    {
        res[ans][0]=b;
        res[ans++][1]=curr;
    }
}

void solve()
{
    for (int i=0; i<v; i++)
    {
        if (used[i]==0) dfs(0);
    }
    for (int i=0; i<v; i++)
    {
        for (int j=0; j<con[i].size(); j++)
        {
            if (con[i][j]<i)
            {
                uv[con[i][j]].push_back(i);
            }
            else
            {
                uv[i].push_back(con[i][j]);
            }
        }
    }
    for (int i=0; i<v; i++)
    {
        for (int j=0; j<uv[i].size(); j++)
        {
            if (uv[i][j]>i) uv[uv[i][j]].push_back(i);
        }
    }
    for (int i=0; i<v; i++)
    {
        dfs2(i, i);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}
/*
4 7
1 2
2 3
3 2
2 1
1 4
2 4
3 4

4 5
1 2
2 3
3 1
3 4
3 4
*/
