/**
* user:  B1075
* fname: Борислав Николаев Семерджиев
* lname: Смолян
* task:  bridges
* score: 0.0
* date:  2017-11-25 08:34:09.057031
*/
#include <bits/stdc++.h>
#define MAXN 1000

using namespace std;

int graph[MAXN][MAXN];
bool visited[MAXN];
int n, m;
vector<pair<int,int>> mE;

int dfs(int x, int remainingN, int remainingE, int start, vector<pair<int, int>> aE)
{
    if(remainingE == 0 && remainingN == 0 && start == x)
    {
        printf("D");
        if(aE.size() < mE.size())
        {
            mE = aE;
        }
    }
    bool t = visited[x];
    if(!t) remainingN--;
    visited[x] = true;
    for(int i = 1; i <= n; i++)
    {
        if(x != i)
        {
            if(graph[x][i])
            {
                graph[x][i]--;
                graph[i][x]--;
                dfs(i, remainingN, remainingE - 1, start, aE);
                graph[x][i]++;
                graph[i][x]++;
            }
        }
    }
    if(!t)
    {
        remainingN++;
        visited[x] = false;
    }
}

int main()
{
    scanf("%d %d", &n, &m);
    for(int i = 0; i < m; i++)
    {
        int v, w;
        scanf("%d %d", &v, &w);
        graph[v][w]++;
        graph[w][v]++;
    }
    for(int i = 1; i <= n; i++)
    {
        dfs(i, n, m, i, vector<pair<int, int>>());
    }
    printf("%d", mE.size());
    return 0;
}

/*
4 7
1 2
2 3
3 2
2 1
1 4
2 4
3 4
*/

/*
4 5
1 2
2 3
3 1
3 4
3 4
*/
