/**
* user:  B1075
* fname: Борислав Николаев Семерджиев
* lname: Смолян
* task:  bridges
* score: 10.0
* date:  2017-11-25 10:22:35.871659
*/
#include <bits/stdc++.h>
#define MAXN 1000

using namespace std;

int graph[MAXN][MAXN];
bool visited[MAXN];
int n, m, k, result;

void dfs(int x, int rE, int rN, int start)
{
    bool t = visited[x];
    if(rE == 0 && rN == 0 && x == start)
    {
        result = 0;
    }
    if(!t)
    {
        rN--;
        visited[x] = true;
    }
    for(int i = 1; i <= n; i++)
    {
        if(graph[x][i])
        {
            graph[x][i]--;
            graph[i][x]--;
            dfs(i, rE - 1, rN, start);
            graph[x][i]++;
            graph[i][x]++;
        }
    }
    if(!t)
    {
        rN++;
        visited[x] = false;
    }
}

int main()
{
    scanf("%d %d", &n, &m);
    for(int i = 0; i < m; i++)
    {
        int v, w;
        scanf("%d %d", &v, &w);
        graph[v][w]++;
        graph[w][v]++;
    }

    dfs(1, m, n, 1);

    printf("%d", result);

    return 0;
}

/*
4 7
1 2
2 3
3 2
2 1
1 4
2 4
3 4
*/

/*
4 5
1 2
2 3
3 1
3 4
3 4
*/
