/**
* user:  B1075
* fname: Борислав Николаев Семерджиев
* lname: Смолян
* task:  bridges
* score: 20.0
* date:  2017-11-25 11:11:15.179423
*/
#include <bits/stdc++.h>
#define MAXN 1000

using namespace std;

int graph[MAXN][MAXN];
int a[MAXN];
bool visited[MAXN];
int n, m,result = -1;
vector<pair<int,int>> answer;

void dfs(int x, int rE, int rN, int start, int k, vector<pair<int,int>> ans)
{
    bool t = visited[x];
    if(rE == 0 && rN == 0 && x == start)
    {
        if(result > k || result == -1)
        {
            result = k;
            answer = ans;
        }
    }
    if(!t)
    {
        rN--;
        visited[x] = true;
    }
    for(int i = 1; i <= n; i++)
    {
        if(graph[x][i])
        {
            graph[x][i]--;
            graph[i][x]--;
            a[x]--;
            a[i]--;
            dfs(i, rE - 1, rN, start, k, ans);
            graph[x][i]++;
            graph[i][x]++;
            a[x]++;
            a[i]++;
        }
    }
    int goI = 1, goD = 0;
    for(int i = 1; i <= n; i++)
    {
        if(a[i] > goD && x != i)
        {
            goI = i;
            goD = a[i];
        }
    }
    if(goI != x)
    {
        vector<pair<int,int>> temp = ans;
        temp.push_back(make_pair(x, goI));
        a[goI]--;
        dfs(goI, rE, rN, start, k + 1, temp);
    }
    if(!t)
    {
        rN++;
        visited[x] = false;
    }
}

int main()
{
    scanf("%d %d", &n, &m);
    for(int i = 0; i < m; i++)
    {
        int v, w;
        scanf("%d %d", &v, &w);
        graph[v][w]++;
        graph[w][v]++;
        a[v]++;
        a[w]++;
    }

    dfs(1, m, n, 1, 0, vector<pair<int,int>>());

    printf("%d\n", answer.size());
    for(int i = 0; i < answer.size(); i++)
    {
        printf("%d %d\n", answer[i].first, answer[i].second);
    }

    return 0;
}

/*
4 7
1 2
2 3
3 2
2 1
1 4
2 4
3 4
*/

/*
4 5
1 2
2 3
3 1
3 4
3 4
*/

/*
4 3
1 2
2 3
3 1
*/
