/**
* user:  B1077
* fname: Александър Георгиев Радославов
* lname: София-град
* task:  bridges
* score: 100.0
* date:  2017-11-25 08:23:50.770530
*/
#include<iostream>
#include<vector>
#include<queue>
using namespace std;
const int maxn = 2000, maxm = 10000;
int n, m;
vector<int> e[maxn];
int st[maxn];
int seg[maxn];
int first_seg[maxn];
int nseg = 1;
vector<pair<int, bool> > frseg[maxn];
vector<int> ans;
int main()
{
    cin >> n >> m;
    for(int i = 0; i < m; i ++)
    {
        int a, b;
        cin >> a >> b;
        e[a].push_back(b);
        e[b].push_back(a);
        st[a] ++;
        st[b] ++;
    }
    for(int i = 1; i <= n; i ++)
    {
        if(seg[i] == 0)
        {
            queue<int> obh;
            obh.push(i);
            seg[i] = nseg;
            first_seg[nseg] = i;
            while(!obh.empty())
            {
                int j = obh.front();
                obh.pop();
                if(st[j] % 2  == 1) frseg[nseg].push_back(pair<int,bool> (j, true) );
                for(int k = 0; k < e[j].size(); k ++)
                {
                    if(!seg[e[j][k]])
                    {
                        obh.push(e[j][k]);
                        seg[e[j][k]] = nseg;
                    }
                }
            }
            nseg ++;
        }
    }
    for(int i = 1;nseg > 2 &&  i < nseg; i ++)
    {
        if(frseg[i].size() > 1)
        {
            for(int j = 0; j < frseg[i].size(); j ++)
            {
                if(frseg[i][j].second)
                {
                    ans.push_back(frseg[i][j].first);
                    frseg[i][j].second = false;
                    break;
                }
            }
        }
        else
        {
            ans.push_back(first_seg[i]);
        }
        int next = (i) % (nseg - 1) + 1;
        if(frseg[next].size() > 1)
        {
            for(int j = 0; j < frseg[next].size(); j ++)
            {
                if(frseg[next][j].second)
                {
                    ans.push_back(frseg[next][j].first);
                    frseg[next][j].second = false;
                    break;
                }
            }
        }
        else
        {
            ans.push_back(first_seg[next]);
        }
    }
    bool space = true;
    for(int i = 1; i < nseg; i ++)
    {
        for(int j = 0; j < frseg[i].size(); j ++)
        {
            if(frseg[i][j].second)
            {
                ans.push_back(frseg[i][j].first);
                space ^= 1;
            }
        }
    }
    cout << ans.size() / 2 << endl;
    for(int i = 0; i < ans.size(); i += 2)
    {
        cout << ans[i] << " " << ans[i + 1] << endl;
    }
}
/*
4 7
1 2
2 3
3 2
2 1
1 4
2 4
3 4
*/
/*
4 3
1 2
2 3
3 1
*/
