/**
* user:  B1081
* fname: Игнес Михаилова Симеонова
* lname: София-град
* task:  bridges
* score: 40.0
* date:  2017-11-25 12:10:46.222554
*/
#include<iostream>
#include<vector>
#include<queue>
using namespace std;

vector<int> susedi[1002];
queue<int> otg[1002];
bool used[1002];

int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);

    int vurhove, rebra;
    cin >> vurhove >> rebra;

    if(vurhove == 1) {
        cout << "0\n";
        return 0;
    }

    for(int i = 0; i < rebra; i ++) {
        int a, b;
        cin >> a >> b;
        if(a != b) {
            susedi[a].push_back(b);
            susedi[b].push_back(a);
        }
    }

    int comp = 0;
    for(int i = 1; i <= vurhove; i++) {
        if(susedi[i].size() == 0) {
            otg[comp].push(i);
            otg[comp].push(i);
            comp++;
        }else if(!used[i]){
            int vruh = i;
            queue<int> q;
            q.push(vruh);
            used[vruh] = true;
            while(!q.empty()) {
                vruh = q.front();
                q.pop();
                if(susedi[vruh].size()%2 != 0) {
                    otg[comp].push(vruh);
                }
                for(int j = 0; j < susedi[vruh].size(); j++) {
                    if(!used[susedi[vruh][j]]) {
                        used[susedi[vruh][j]] = true;
                        q.push(susedi[vruh][j]);
                    }
                }
            }
            comp++;
        }
    }

    //cout << "AAA" << comp << "\n";

    int br = 0, last = 1;
    vector<pair<int,int> > izhod;
    for(int i = 0; i < comp; i++) {
        while(!otg[i].empty()){
            //cout << i << "*  \n";
            bool ima=false;
            if(last >= comp) {
                last = 1;
            }

            for(int j = last; j < comp and !otg[i].empty(); j ++) {
                if(!otg[j].empty() and j!=i){
                    ima = true;
                    last = j + 1;
                    izhod.push_back({otg[i].front(), otg[j].front()});
                    //cout << otg[i].front() << " " << otg[j].front() << "\n";
                    otg[i].pop();
                    otg[j].pop();
                    br++;
                }
            }

            if(!ima){
                //cout << "#" << i << "#";
                if(otg[i].size() == 2) {
                    //cout<<"TUK";
                    int a = otg[i].front();
                    otg[i].pop();
                    int b = otg[i].front();
                    otg[i].pop();
                    if(a != b) {
                        izhod.push_back({a, b});
                        //cout << a << " " << b << "\n";
                        br++;
                    }else{
                        int j;
                        for(j = 1; j == a and j <= vurhove; j ++){}
                        izhod.push_back({a,j});
                        izhod.push_back({a,j});
                        //cout << a << " " << j << "\n";
                        //cout << a << " " << j << "\n";
                        br+=2;
                    }
                }else{
                    //cout << "TAM\n";
                    while(!otg[i].empty()) {
                        //cout << otg[i].size() << "; ";
                        int a = otg[i].front();
                        //cout << otg[i].front() << " ";
                        otg[i].pop();
                        int b = otg[i].front();
                        //cout << otg[i].front() << "\n";
                        otg[i].pop();
                        izhod.push_back({a,b});
                        br++;
                    }
                }
            }
        }
    }

    cout << br << "\n";
    for(int i = 0; i < br; i ++) {
        cout << izhod[i].first << " " << izhod[i].second << "\n";
    }

    return 0;
}
