/**
* user:  B1001
* fname: Georgi
* lname: Petkov
* task:  bridges
* score: 10.0
* date:  2017-11-25 09:27:31.254904
*/
#include <bits/stdc++.h>
#define MAXN 1024
using namespace std;
int n, m;
vector <int> v[MAXN];
bool used[MAXN];
map <pair <int, int>, int> cnt;
map <pair <int, int>, int> curr_cnt;
int last_pos;
void dfs(int u)
{
    last_pos = u;
    used[u] = 1;
    for (int i = 0; i < v[u].size(); i++)
        if (curr_cnt[make_pair(u, v[u][i])] > 0)
    {
        curr_cnt[make_pair(u, v[u][i])]--;
        curr_cnt[make_pair(v[u][i], u)]--;
        dfs(v[u][i]);
        break;
    }
}
int main()
{
    scanf("%d%d", &n, &m);
    for (int i = 1; i <= m; i++)
    {
        int a, b;
        scanf("%d%d", &a, &b);
        v[a].push_back(b);
        v[b].push_back(a);
        cnt[make_pair(a, b)]++;
        cnt[make_pair(b, a)]++;
    }
    int mincnt = 1000000000;
    vector <pair <int, int> > ans;
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= n; j++)
            used[j] = 0;
            curr_cnt = cnt;
            dfs(i);
            vector <pair <int, int> > curr;
            vector <int> nb[MAXN];
            vector <pair <int, int> > unused;
            for (auto it = curr_cnt.begin(); it != curr_cnt.end(); it++)
                if (it->second != 0 && it->first.first < it->first.second)
                unused.push_back(it->first);
           for (int j = 0; j < unused.size(); j++)
           {
               nb[unused[j].first].push_back(unused[j].second);
               nb[unused[j].second].push_back(unused[j].first);
           }
           if (unused.size() == 1)
           {
               curr.push_back(make_pair(last_pos, unused[0].first));
               curr.push_back(make_pair(unused[0].second, i));
           }
           if (curr.size() < mincnt && unused.size() <= 1)
           {
               mincnt = curr.size();
               ans = curr;
           }
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); i++)
        cout << ans[i].first << " " << ans[i].second << endl;
}
/*
4 7
1 2
2 3
3 2
2 1
1 4
2 4
3 4
*/
