/**
* user:  B1002
* fname: Konstantin
* lname: Kamenov
* task:  chain
* score: 100.000000014
* date:  2017-11-25 07:27:25.284139
*/
#include<iostream>
#include<stack>
struct number{
    int value,index;
};
number numbers[500000];
int nextbigger[500000];
std::stack<number> larger;
int chainsize[500000];
int calc(int i){
    if(i==-1){
        return 0;
    }
    if(chainsize[i]!=-1){
        return chainsize[i];
    }
    int ans=calc(nextbigger[i])+1;
    chainsize[i]=ans;
    return ans;
}
int main(){
    int n,a;
    std::cin>>n;
    for(int i=0;i<n;i++){
        chainsize[i]=-1;
        std::cin>>a;
        numbers[i]={a,i};
    }
    for(int i=0;i<n;i++){
        while(!larger.empty() && larger.top().value<numbers[i].value){
            number curr=larger.top();
            nextbigger[curr.index]=i;
            larger.pop();
        }
        larger.push(numbers[i]);
    }
    while(!larger.empty()){
        number curr=larger.top();
        nextbigger[curr.index]=-1;
        larger.pop();
    }
    for(int i=0;i<n;i++){
        std::cout<<calc(i)-1<<" ";
    }
    std::cout<<std::endl;
    return 0;
}
