/**
* user:  B1003
* fname: Martin
* lname: Kopchev
* task:  bridges
* score: 40.0
* date:  2017-11-25 10:19:43.176164
*/
#include<bits/stdc++.h>
using namespace std;
const int nmax=1e3+42;
int n,m;
int SZ[nmax];
vector<int> adj[nmax];
vector< pair<int,int> >outp,now;
void print()
{
int sz=outp.size();
cout<<sz<<endl;
for(auto k:outp)
    cout<<k.first<<" "<<k.second<<endl;
//for(int i=1;i<=n;i++)cout<<parent[i]<<" ";cout<<endl;
}
int WALL;
bool seen[nmax];
void go(int node)
{
if(seen[node])return;
seen[node]=1;
for(auto k:adj[node])
    go(k);
for(auto k:now)
{
if(k.first==node)go(k.second);
if(k.second==node)go(k.first);
}

}
void dfs(int level)
{
if(level>WALL||level>=outp.size())return;
bool good=1;
for(int i=1;i<=n;i++)
    if(SZ[i]%2==1)good=0;
memset(seen,0,sizeof(seen));
go(1);
for(int i=1;i<=n;i++)
    if(seen[i]==0)good=0;

if(good)
{
//cout<<"level "<<level<<endl;
if(outp.size()>now.size())outp=now;
return;
}
for(int i=1;i<=n;i++)
    for(int j=i+1;j<=n;j++)
    {
    SZ[i]++;
    SZ[j]++;
    now.push_back({i,j});
    dfs(level+1);
    SZ[i]--;
    SZ[j]--;
    now.pop_back();
    }

}
int main()
{
cin>>n>>m;
int a,b;
for(int i=1;i<=2*n;i++)outp.push_back({i,i});
for(int i=1;i<=m;i++)
{
cin>>a>>b;
SZ[a]++;
SZ[b]++;
adj[a].push_back(b);
adj[b].push_back(a);
}
WALL=2*n;
dfs(0);
print();
return 0;
}
/*
4 7
1 2
2 3
3 2
2 1
1 4
2 4
3 4


4 5
1 2
2 3
3 1
3 4
3 4

4 3
1 2
2 3
3 1

4 2
1 2
3 4

6 2
3 4
5 6

6 4
1 2
3 4
4 5
5 6

12 12
1 2
1 3
2 3
3 4
4 5
4 6
5 6
7 8
8 9
9 10
10 11
9 12

4 3
1 2
1 2
3 4

6 5
1 2
2 1
3 4
4 3
5 6
*/
