/**
* user:  B1004
* fname: Zahari
* lname: Marinov
* task:  chain
* score: 100.000000014
* date:  2017-11-25 11:49:21.603251
*/
#include <iostream>
#include <queue>
#include <stack>
#include <vector>
#include <cstdio>
#define N 500002
using namespace std;
int n,a[N],ans[N],f[N];
stack<int> st;
queue <int> q;
vector<int> g[N];

void bfs(int v)
{
    f[v] = 1;
    q.push(v);
    while(!q.empty())
    {
        v = q.front();
        for(int v2:g[v])
        {
            if(f[v2]==0)
            {
                ans[v2] = ans[v]+1;
                q.push(v2);
                f[v2]=1;
            }
        }
        q.pop();
    }
}

void solve()
{
    int i;
    for(i=n; i>=1; i--)
    {
        if(f[i]==0)
            bfs(i);
    }
    for(i=1; i<=n; i++)
    {
        if(i!=1) printf(" ");
        printf("%i",ans[i]);
    }
    printf("\n");
}

void input()
{
    cin>>n;
    int i;
    for(i=1; i<=n; i++)
    {
        scanf("%i",a+i);
        while(st.empty()==0 && a[st.top()]<a[i])
        {
            g[i].push_back(st.top());
            st.pop();
        }
        st.push(i);
    }
}

int main()
{
    input();
    solve();
    return 0;
}
