/**
* user:  B1004
* fname: Zahari
* lname: Marinov
* task:  shopping
* score: 90.0
* date:  2017-11-25 11:56:28.798204
*/
#include <iostream>
#include <vector>
#include <cmath>
#include <cstdio>
#define N 100002
using namespace std;
typedef long long ll;
const ll lim = 1e9;
bool sign[N];
int a[N],n,k;
vector<ll> ans[N];

void euql(ll a,ll b,ll &ans,ll &u,ll &v)
{
    ll r,q,x1=1,y1=0,x2=0,y2=1,xt,yt;
    while(b!=0)
    {
        r = a%b;
        q = a/b;
        a = b;
        b = r;
        xt = x2; yt = y2;
        x2 = x1 - x2*q; y2 = y1 - y2*q;
        x1 = xt; y1 = yt;
    }
    ans = a;
    u = x1;
    v = y1;
}

void write(ll l,ll r,ll mn)
{
    ll i;
    bool s=0;
    if(mn<0) s=1;
    mn = abs(mn);
    for(i=l; i<=r; i++)
    {
        sign[i]^=s;
        ans[i].push_back(mn);
    }
}

void gcd(ll l,ll r,ll &ans)
{
    if(l==r)
        {ans=a[l]; return;}

    ll nod,u,v,m,aa,bb;

    m = (l+r)/2;
    gcd(l,m,aa);
    gcd(m+1,r,bb);

    euql(aa,bb,nod,u,v);
    write(l,m,u);
    write(m+1,r,v);
    ans = nod;
}

void solve()
{
    ll nod,i,j;
    gcd(1,n,nod);
    if(k%nod==0)
    {
        write(1,n,k/nod);
        for(i=1; i<=n; i++)
        {
            if(i!=1) printf(" ");
            if(sign[i]==1) printf("-");
            for(j=0; j<ans[i].size(); j++)
            {
                if(j!=0) printf("*");
                printf("%lli",ans[i][j]);
            }
            ans[i].clear();
        }
        printf("\n");
    }
    else
    {
        cout<<"No solutions"<< endl;
        for(i=1; i<=n; i++) ans[i].clear();
    }
}

void input()
{
    cin>>n;
    int i;
    for(i=1; i<=n; i++)
    {
        scanf("%lli",a+i);
        sign[i]=0;
    }
    cin>>k;
}

int main()
{
    ll t,i;
/*    ll aa,bb,u,v,nod;
    cin>>aa>>bb;
    euql(aa,bb,nod,u,v);
    cout<<u<<" "<<v<<" "<<nod<< endl;*/

    cin>>t;
    for(i=1; i<=t; i++)
    {
        input();
        solve();
    }
    return 0;
}
/*
2
2
3 5
11
4
30 42 70 105
413

1
5
27457832 75864744 12986744 22222222 12365436
48726548

*/
