/**
* user:  B1006
* fname: Dobrin
* lname: Bashev
* task:  chain
* score: 100.000000014
* date:  2017-11-25 11:07:42.216735
*/
#include <iostream>
#include <stack>
#define endl '\n'
using namespace std;

const int MAXN = 500005;

int n;
int a[MAXN], b[MAXN];
stack<int> s;

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
    }

    for (int i = n; i >= 1; -- i)
    {
        while (!s.empty() and a[s.top()] <= a[i])
        {
            s.pop();
        }

        if (s.empty()) b[i] = 0;
        else b[i] = b[s.top()] + 1;

        s.push(i);
    }

    for (int i = 1; i <= n; ++ i)
    {
        cout << b[i] << ' ';
    }

    cout << endl;
    return 0;
}

/*
11
3 2 4 2 11 2 7 5 8 10 6
*/

