/**
* user:  B1008
* fname: Viktor
* lname: Kojuharov
* task:  chain
* score: 100.000000014
* date:  2017-11-25 07:46:46.129211
*/
#include<iostream>
#include<queue>

using namespace std;

int a[500001];
int nxt[500001];

struct cmp
{
    bool operator()(pair<int,int> x,pair<int,int> y)
    {
        return x.first>y.first;
    }
};

int main ()
{
    int n,i;
    pair<int,int> p;

    priority_queue<pair<int,int>,vector<pair<int,int>>,cmp> q;

    cin>>n;

    for(i=0;i<n;i++)nxt[i]=-1;

    for(i=0;i<n;i++)
    {
        cin>>a[i];
        while(!q.empty() && q.top().first<a[i])
        {
            nxt[q.top().second]=i;
            q.pop();
        }
        p.first=a[i];
        p.second=i;
        q.push(p);
    }

    for(i=n-1;i>=0;i--)
    {
        //cout<<nxt[i]<<endl;
        if(nxt[i]==-1)nxt[i]=0;
        else nxt[i]=nxt[nxt[i]]+1;
    }

    for(i=0;i<n-1;i++)
        cout<<nxt[i]<<" ";

    cout<<nxt[i]<<endl;

    return 0;
}
