/**
* user:  B1008
* fname: Viktor
* lname: Kojuharov
* task:  shopping
* score: 10.0
* date:  2017-11-25 08:39:41.520723
*/
#include<iostream>
#include<vector>

using namespace std;

int extended_euclid(int a,int b,int &x,int &y)
{
    if(b==0)
    {
        x=1;
        y=0;
        return a;
    }

    int x2,y2;
    int d=extended_euclid(b,a%b,x2,y2);

    x=y2;
    y=x2-(a/b)*y2;

    return d;
}

int a[100001];
int b[100001];
vector<int> c[100001];

int main ()
{
    int t;

    ios::sync_with_stdio(false);

    cin>>t;

    for(t;t>0;t--)
    {
        int k,i,n,x,y,st=1,j,p;

        cin>>k;

        for(i=0;i<k;i++)
            cin>>a[i];

        cin>>n;

        p=k;

        for(i=0;i<k;i++)b[i]=a[i];

        while(p>1)
        {
            for(i=0;i<=(p-1);i+=2)
            {
                b[i]=extended_euclid(b[i],b[i+1],x,y);
                for(j=i*st;j<(i+1)*st;j++)c[j].push_back(x);
                for(j=(i+1)*st;j<(i+2)*st;j++)c[j].push_back(y);
            }

            for(i=0;i<=(p-1)/2;i++)
            {
                b[i]=b[2*i];
            }
            st*=2;
            p=p/2+p%2;
        }

        if(n%p!=0)
        {
            cout<<"No solutions"<<endl;
            continue;
        }
        n=n/p;

        for(i=0;i<k;i++)c[i].push_back(n);

        for(i=0;i<k;i++)
        {
            for(j=0;j<c[i].size()-1;j++)
            {
                cout<<c[i][j]<<"*";
            }
            cout<<c[i][j]<<" ";
        }
        cout<<endl;
    }

    return 0;
}
