/**
* user:  B1011
* fname: Stoyan
* lname: Malinin
* task:  shopping
* score: 30.0
* date:  2017-11-25 09:47:05.883113
*/
#include<iostream>
#include<cmath>

using namespace std;

const int MAXN = 1005;

int T;

int k;
long long s[MAXN], n;

long long x1, x2, Y1, y2, r, q;
long long a, b, c;

bool succes = false;

int extEuclid()
{
    x1 = 1;Y1 = 0;
    x2 = 0;y2 = 1;
    while(b!=0)
    {
        r = a%b;
        q = a/b;

        a = b;
        b = r;

        r = x1 - x2*q;
        x1 = x2;x2 = r;

        r = Y1 - y2*q;
        Y1 = y2;y2 = r;

        //cout << y2 << " " << b << '\n';
    }

    return a;
}

void fixNumber(long long x)
{
    if(x<0)
    {
        cout << "-1";
        x*= -1;
    }
    else cout << "1";

    long long d = 2;

    while(x!=1 && x>1e9)
    {
        if(x%d==0)
        {
            cout << "*" << d;
            x/=d;
        }
        else d++;
    }
    cout << "*" << x;
}

long long limit;
bool checkImpossible(long long x) //big and prime
{
    if(x<=1e9) return false;

    limit = sqrt(x);
    for(int d = 2;d<=x;d++)
        if(x%d==0) return false;

    return true;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int operations;
    long long x, y, n1;

    cin >> T;
    for(int t = 0;t<T;t++)
    {
        cin >> k;
        for(int i = 0;i<k;i++)
            cin >> s[i];
        cin >> n;
        n1 = n;

        if(k==2)
        {
            a = s[0];
            b = s[1];
            long long d = extEuclid();


            //cout << x1 << " " << Y1 << " || " << x2 << " " << y2 << '\n';

            x = x1;
            y = Y1;

            //cout << y << '\n';
            //cout << s[0] << "*" << x*(n/d) << " + " << s[1] << "*" << y*(n/d) << '\n';

            if( s[0] * x*(n/d) + s[1] * y*(n/d) != n
                || checkImpossible(x*(n/d)) || checkImpossible(y*(n/d)) ) cout << "No solutions" << '\n';
            else
            {
                fixNumber(x*(n/d));
                cout << " ";

                fixNumber(y*(n/d));
                cout << '\n';
            }
        }
        else if(k==3)
        {
            operations = 0;

            for(long long i = 0;;i++)
            {
                operations++;

                a = s[0];
                b = s[1];
                n = n1 + s[2]*i;

                long long d = extEuclid();


                //cout << x1 << " " << Y1 << " || " << x2 << " " << y2 << '\n';

                x = x1;
                y = Y1;

                //cout << y << '\n';
                //cout << s[0] << "*" << x*(n/d) << " + " << s[1] << "*" << y*(n/d) << '\n';

                if( s[0] * x*(n/d) + s[1] * y*(n/d) == n
                   && checkImpossible(x*(n/d))==false && checkImpossible(y*(n/d))==false)
                {
                    fixNumber(x*(n/d));
                    cout << " ";

                    fixNumber(y*(n/d));
                    cout << " ";

                    cout << -i << '\n';

                    break;
                }
                if(operations>=5*1e5)
                {
                    cout << "No solutions" << '\n';
                    break;
                }
            }
        }
        else if(k<=1000)
        {
            for(int i = 0;i<k-1;i++)
            {
                for(int j = i+1;j<k;j++)
                {
                    a = s[i];
                    b = s[j];

                    long long d = extEuclid();

                    x = x1;
                    y = Y1;

                    if( s[i] * x*(n/d) + s[j] * y*(n/d) == n
                   && checkImpossible(x*(n/d))==false && checkImpossible(y*(n/d))==false)
                    {
                        for(int p = 0;p<k;p++)
                        {
                            if(p==i) fixNumber(x*(n/d));
                            else if(p==j) fixNumber(y*(n/d));
                            else cout << "0";

                            if(p!=k-1) cout << " ";
                            else cout << '\n';
                        }

                        return 0;
                    }
                }
            }

            cout << "No solutions" << '\n';
        }
        else cout << "No solutions" << '\n';
    }
}
