/**
* user:  B1011
* fname: Stoyan
* lname: Malinin
* task:  bridges
* score: 10.0
* date:  2017-11-25 10:50:09.540066
*/
#include<iostream>
#include<stack>

using namespace std;

const int MAXN = 1005;

int V, E, u, v;

int G[MAXN][MAXN];

stack < pair <int, int> > edge;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int number;

    cin >> V >> E;
    for(int i = 0;i<E;i++)
    {
        cin >> u >> v;
        if(u>v) swap(u, v);

        G[u][v]++;
    }

    if(E<V)
    {
        cout << (V) - E << '\n';

        for(int i = 1;i<V;i++)
        {
            for(int j = i+1;j<=V;j++)
            {
                if(G[i][j]==0) cout << i << " " << j << '\n';
            }
        }
    }
    else if(E!=V)
    {
        for(int i = 1;i<V;i++)
        {
            for(int j = i+1;j<=V;j++)
            {
                if(G[i][j]==1) edge.push(make_pair(i, j));
            }
        }

        cout << edge.size() << '\n';
        while(edge.empty()==false)
        {
            cout << edge.top().first << " " << edge.top().second << '\n';
            edge.pop();
        }
    }
    else cout << "0" << '\n';
}
