/**
* user:  B1077
* fname: Александър Георгиев Радославов
* lname: София-град
* task:  shopping
* score: 40.0
* date:  2017-11-25 10:18:00.624135
*/
#include<iostream>
#include<algorithm>
#include<cmath>
#include<vector>
using namespace std;
const int max_value = 1e9;

struct num
{
    vector<int> mul;
    bool sign;
    num()
    {
        sign = true;
        mul.push_back(0);
    }
    void set(int a)
    {
        sign = a > 0;
        mul.clear();
        mul.push_back(abs(a));
    }
    void m(int a)
    {
        if(a == 0)
        {
            set(0);
            return;
        }
        if(a < 0)  sign ^= 1;
        a = abs(a);
        if(mul[mul.size() - 1] * a < max_value) mul[mul.size() - 1] *= a;
        else    mul.push_back(a);
    }
    void print()
    {
        if(mul[0] != 0 && !sign)   cout << "-";
        for(int i = 0; i < mul.size(); i ++)
        {
            if(i > 0)   cout << "*";
            cout << mul[i];
        }
    }
};

int evk(int a, int b,int& x, int& y)
{
    int x1 = 1, y1 = 0;
    int x2 = 0, y2 = 1;
    while(1)
    {
        if(a < b)
        {
            swap(a,b);
            swap(x1,x2);
            swap(y1,y2);
        }
        int c = a / b, d = a % b;
        a = d;
        x1 = x1 - c * x2;
        y1 = y1 - c * y2;
        if(d == 0)  break;
    }
    if(a < b)
    {
        swap(a,b);
        swap(x1,x2);
        swap(y1,y2);
    }
    x = x1;
    y = y1;
    return a;
}
int test()
{
    int n,k;
    cin >> k;
    pair<int,int> a[k];
    int ord[k];
    for(int i = 0; i < k; i ++)
    {
        cin >> a[i].first;
        a[i].first *= -1;
        a[i].second = i;
    }
    sort(a, a + k);
    for(int i = 0; i < k; i ++)
    {
        ord[a[i].second] = i;
    }
    cin >> n;


    num mask[k];
    mask[0].set(1);
    int gcd = -a[0].first;
    for(int i = 1;n % gcd != 0 && i < k; i ++)
    {
        //cout << gcd << endl;
        int x, y;
        int tgcd = evk(gcd , -a[i].first , x, y);
        mask[i].set(y);
        for(int j = 0; j < i; j ++)
        {
            mask[j].m(x);
        }
        gcd = tgcd;
    }
    if(n % gcd != 0)
    {
        cout << "No solutions";
    } else {
        for(int i = 0; i < k; i ++)
        {
            mask[ord[i]].print();
            cout << "*" <<  n / gcd << " ";
        }
    }
}

int main()
{

    ios::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    for(int i = 0; i < t; i ++)
    {
        test();
        cout << endl;
    }
}
/*
2
4
70 30 42 105
413
4
30 42 70 105
413

*/

/*
1
2
3 5
11
*/
