/**
* user:  B1077
* fname: Александър Георгиев Радославов
* lname: София-град
* task:  shopping
* score: 40.0
* date:  2017-11-25 11:09:14.627776
*/
#include<iostream>
#include<algorithm>
#include<cmath>
#include<vector>
using namespace std;
const long long max_value = 1e18;

struct num
{
    vector<long long> mul;
    bool sign;
    num()
    {
        sign = true;
        mul.push_back(0);
    }
    void set(long long a)
    {
        sign = a > 0;
        mul.clear();
        mul.push_back(abs(a));
    }
    void m(long long a)
    {
        if(a == 0)
        {
            set(0);
            return;
        }
        if(a < 0)  sign ^= 1;
        a = abs(a);
        if(mul[mul.size() - 1] * a < max_value) mul[mul.size() - 1] *= a;
        else    mul.push_back(a);
    }
    void print()
    {
        if(mul[0] != 0 && !sign)   cout << "-";
        for(long long i = 0; i < mul.size(); i ++)
        {
            if(i > 0)   cout << "*";
            cout << mul[i];
        }
    }
};

long long evk(long long a, long long b,long long& x, long long& y)
{
    long long x1 = 1, y1 = 0;
    long long x2 = 0, y2 = 1;
    while(1)
    {
        if(a < b)
        {
            swap(a,b);
            swap(x1,x2);
            swap(y1,y2);
        }
        long long c = a / b, d = a % b;
        a = d;
        x1 = x1 - c * x2;
        y1 = y1 - c * y2;
        if(d == 0)  break;
    }
    if(a < b)
    {
        swap(a,b);
        swap(x1,x2);
        swap(y1,y2);
    }
    x = x1;
    y = y1;
    return a;
}
long long test()
{
    long long n,k;
    cin >> k;
    pair<long long,long long> a[k];
    long long ord[k];
    for(long long i = 0; i < k; i ++)
    {
        cin >> a[i].first;
        a[i].first *= 1;
        a[i].second = i;
    }
    sort(a, a + k);
    for(long long i = 0; i < k; i ++)
    {
        ord[a[i].second] = i;
    }
    cin >> n;



    num mask[k];
    int px[k] = {};
    int py[k] = {};
    mask[0].set(1);
    long long gcd = a[0].first;
    long long i = 1;
    for(;n % gcd != 0 && i < k; i ++)
    {
        //cout << gcd << endl;
        long long x, y;
        long long tgcd = evk(gcd , a[i].first , x, y);
        px[i] = x;
        py[i] = y;
        /*for(long long j = 0; j < i; j ++)
        {
            mask[j].m(x);
        }*/
        gcd = tgcd;
    }
    num temp;
    temp.set(1);
    for(int j = i - 1; j > 0; j --)
    {
        mask[j] = temp;
        mask[j].m(py[j]);
        temp.m(px[j]);
        //mask[j].print();
        //cout << endl;
    }
    mask[0] = temp;
    if(n % gcd != 0)
    {
        cout << "No solutions";
    } else {
        for(long long j = 0; j < k; j ++)
        {
            mask[ord[j]].print();
            cout << "*" <<  n / gcd << " ";
        }
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    long long t;
    cin >> t;
    for(long long i = 0; i < t; i ++)
    {
        test();
        cout << endl;
    }
}
/*
2
4
70 30 42 105
413
5
30 42 42 70 105
413

*/

/*
1
2
3 5
11
*/
