/**
* user:  B1080
* fname: Димо Димов Чанев
* lname: София-град
* task:  shopping
* score: 20.0
* date:  2017-11-25 11:34:52.246427
*/
#include <iostream>
#include <vector>

std::vector<std::vector<long long>> inp;

void pr(long long n) {
    if(n > 1e9) {
        for(int i = 2; i * i < n && n > 1e9; i++) {
            if(n % i == 0) {
                std::cout << i << "*";
            }
        }
    } else if(n < -1e9) {
        std::cout << "-1*";
        n *= -1;
        for(int i = 2; i * i < n && n > 1e9; i++) {
            if(n % i == 0) {
                std::cout << i << "*";
            }
        }
    }
    std::cout << n;
}

bool calc(long long p, long long n, long long z) {
    if(z == 2) {
        long long a = 0;
        while(true) {
            long long b1 = (n - inp[p][0] * a) / inp[p][1];
            long long b2 = (n + inp[p][0] * a) / inp[p][1];
            if(b1 * inp[p][1] + inp[p][0] * a == n) {
                pr(a);
                std::cout << " ";
                pr(b1);
                return true;
            }
            if(b2 * inp[p][1] + inp[p][0] * a == n) {
                pr(-a);
                std::cout << " ";
                pr(b2);
                return true;
            }
            a++;
            if(a == 1e9)
                return false;
        }
    }
    long long a = 0;
    while(true) {
        if(calc(p, n - a, z - 1)) {
            std::cout << " ";
            pr(a);
            return true;
        }
        if(calc(p, n + a, z - 1)) {
            std::cout << " ";
            pr(-a);
            return true;
        }
        a++;
        if(a == 1e9)
            return false;
    }
}

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    long long n;
    long long t;
    std::cin >> t;
    inp.resize(t);
    for(long long q = 0; q < t; q++) {
        long long k;
        std::cin >> k;
        inp[q].resize(k);
        for(long long i = 0; i < k; i++) {
            std::cin >> inp[q][i];
        }
    }
    std::cin >> n;
    for(long long q = 0; q < t; q++) {
        if(!calc(q, n, inp[q].size())) {
            std::cout << "No solutions";
        }
        std::cout << "\n";
    }
    return 0;
}
