/**
* user:  B1081
* fname: Игнес Михаилова Симеонова
* lname: София-град
* task:  chain
* score: 100.000000014
* date:  2017-11-25 08:54:39.902201
*/
#include<iostream>
#include<vector>
#include<queue>
#include<set>
using namespace std;

struct dve{
    int v,i;
    const bool operator < (const dve& a) const {
        return this->v < a.v;
    }
};

multiset<dve> mset;
vector<int> susedi[500001];
queue<int> q;
int n,a[500001],used[500001];

inline void bfs(int vruh) {
    used[vruh] = 0;
    q.push(vruh);
    while(!q.empty()) {
        vruh = q.front();
        q.pop();
        for(int i = 0; i < susedi[vruh].size(); i++){
            if(used[susedi[vruh][i]] == -1){
                used[susedi[vruh][i]] = used[vruh] + 1;
                q.push(susedi[vruh][i]);
            }
        }
    }
}

int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);

    int n;
    cin >> n;
    for(int i = 0; i < n; i ++) {
        used[i] = -1;
        cin >> a[i];
        mset.insert({a[i],i});
        if(a[i] != mset.begin()->v) {
            auto it = mset.lower_bound({a[i],i});

            //cout << a[i] << " " << it->v;
            auto cpy = it;
            it--;
            while(it != mset.begin()) {
                //cout << "A";
                susedi[i].push_back(it->i);
                it--;
            }
            susedi[i].push_back(it->i);
            //cout << cpy->v << " " << mset.begin() -> v << "\n";
            mset.erase(mset.begin(),cpy);
        }
    }

    /*for(int  i = 0; i < n; i++) {
        cout << "i " << i<< ": ";
        for(int j = 0; j < susedi[i].size(); j++) {
            cout << susedi[i][j] << " ";
        }
        cout << "\n";
    }*/
    //cout<<"NESTO\n";
    for(auto it = mset.begin(); it!=mset.end(); it++) {
        bfs(it->i);
    }
    n--;
    for(int i = 0; i < n; i++){
        cout << used[i] << " ";
    }
    cout << used[n] << "\n";

    return 0;
}
