/**
* user:  B1083
* fname: Станислав Чавдаров Николов
* lname: София-град
* task:  shopping
* score: 0.0
* date:  2017-11-25 08:35:03.728004
*/
#include <iostream>
#include <stdlib.h>

const long long MAX_K = 100000 + 3;
long long price[MAX_K];
long long out[MAX_K];

long long k, target;

long long seed = 0xa5bc77d;
long long rnd() {
    /*seed ^= 0x175d;
    seed << 2;
    seed ^= 0x18a;*/
    return rand();
    return seed;
}

const long long myabs(long long n) {
    return (n < 0 ? -n : n);
}

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    long long t;
    std::cin >> t;
    for(long long _ = 0;_ < t;++ _) {
        std::cin >> k;
        for(long long i = 0;i < k;++ i) std::cin >> price[i];
        for(long long i = 0;i < k;++ i) out[i] = 0;
        std::cin >> target;
        long long curr = 0;
        long long bestD = target;

        bool nosol = false;
        long long fails = 0;
        while(curr != target) {
            const long long idx1 = rnd() % k;
            const long long idx2 = rnd() % k;

            const long long diffv1 = rnd() % 4 - 2;
            const long long diffv2 = rnd() % 4 - 2;

            const long long newD = myabs(curr + price[idx1] * diffv1 + price[idx2] * diffv2 - target);
            if( newD < bestD ) {
                bestD = newD;
                out[idx1] += diffv1;
                out[idx2] += diffv2;
                curr += price[idx1] * diffv1 + price[idx2] * diffv2;
            } else {
                fails ++;
            }

            /*
            for(int i = 0;i < 10;++ i) {
                const int diffv = rnd() % 10 - 5;
                const int newD = myabs(curr + price[idx] * diffv - target);
                if( newD < bestD ) {
                    bestD = newD;
                    out[idx] += diffv;
                    curr += price[idx] * diffv;
                    //std::cout << idx << " " << diffv << std::endl;
                    //std::cout << "now " << bestD << ' ' << curr << std::endl;
                    break;
                }
                fails ++;
            }*/
            if(fails > 1000000) {
                nosol = true;
                break;
            }

        }
        if(nosol) {
                std::cout << "No solutions" << std::endl;
        } else {
            for(long long i = 0;i < k;++ i) std::cout << out[i] << ' ';
            std::cout << std::endl;
        }
    }

    return 0;
}
