/**
* user:  B1083
* fname: Станислав Чавдаров Николов
* lname: София-град
* task:  bridges
* score: 20.0
* date:  2017-11-25 09:54:03.067417
*/
#include <iostream>
#include <queue>

const int MAX_N = 1000 + 2;
int cnt[MAX_N];
int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n, m;
    std::cin >> n >> m;
    for(int i = 0;i < m;++ i) {
        int a, b;
        std::cin >> a >> b;
        a --;
        b --;
        cnt[a] ++;
        cnt[b] ++;
    }

    std::queue<int> change;
    int odd = 0, zero = 0;
    for(int i = 0;i < n;++ i) {
        if(cnt[i] > 0 and cnt[i] % 2 == 1) {
            odd ++;
            change.push(i);
        }
        if(cnt[i] == 0) {
            zero ++;
            change.push(i);
        }
    }

    if((odd + zero) % 2 == 0) {
        std::cout << change.size() / 2 << std::endl;
        while(change.size()) {
            int a, b;
            a = change.front();
            change.pop();
            b = change.front();
            change.pop();
            std::cout << a+1 << ' ' << b+1 << std::endl;
        }
    } else {
        std::cout << 0 << std::endl;
    }
    return 0;
}
