/**
* user:  B1083
* fname: Станислав Чавдаров Николов
* lname: София-град
* task:  chain
* score: 47.058823536
* date:  2017-11-25 10:36:25.732337
*/
#include <iostream>

const int MAX_N = 500000 + 3;
int inp[MAX_N];
int ans[MAX_N];
int tree[MAX_N * 4];

int n;
int max = 0;
int start = 1;


int query(int curr, int idx, int val, int l, int r) {
    //std::cout << "in " << curr << std::endl;
    if(r <= idx + start) return -1;
    if(curr >= l and curr < r) {
        if(inp[curr-start] > val) return curr - start;
        return -1;
    }
    if(tree[curr] <= val) {
        return -1;
    }
    int m = (l + r) / 2;
    int q = query(curr * 2, idx, val, l, m);
    if(q != -1) return q;
    return query(curr * 2 + 1, idx, val, m, r);

}

void build(int idx, int l, int r) {
    //std::cout << idx << ' ' << l << ' ' << r << std::endl;
    if(idx >= l and idx < r) {
        tree[idx] = inp[idx - start];
        return;
    }
    const int m = (l + r ) / 2;
    build(idx * 2, l, m);
    build(idx * 2 + 1, m, r);
    tree[idx] = std::max(tree[idx * 2], tree[idx * 2 + 1]);
}

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    std::cin >> n;
    for(int i = 0;i < n;++ i) std::cin >> inp[i];

    while(start < n) start *= 2;
    //std::cout << start << std::endl;
    build(1, start, start*2);

    /*
    while(true) {
            int a, b;
        std::cin >> a;
    std::cout << query(1, a, inp[a], start, start * 2) << std::endl;
    }*/

    ans[n-1] = 0;
    for(int i = n-2;i >= 0;-- i) {
        int q = query(1, i, inp[i], start, start * 2);
        if(q == -1) continue;
        ans[i] = ans[q] + 1;
    }

    for(int i = 0;i < n;++ i) std::cout << ans[i] << ' ';
    return 0;
}
